#ifndef NETWORK_H
#define NETWORK_H 

#include <iostream>
#include <sigc++/sigc++.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <unistd.h>
#include <pthread.h>
#include <string.h>
#include <cstdio>
#include <signal.h>
#include <list>
#include <glibmm/ustring.h>

using namespace std;

#define EMITSIGNAL	SIGUSR1+5

class NetWork;

typedef struct arg {
	int		pid;
	int		sockfd;
	NetWork*	network;
}ARG;


class NetWork
{
public:
	NetWork(string url = "");
	~NetWork();

	bool	get();
	bool	send_server(int sockfd);
	bool	set_url(const string &url);
	void	append_request_head(const string &headerName, const string &headerValue);
	string get_Response_head();
	string get_Response_text();

	//*
	int	data_to_ResponseHead(const string &data);
	int	data_to_ResponseText(const string &data, int pos);

	int	get_Response_sign(const string &sign, string *ret);
	int	get_Response_code();

	void	emit_signal(const string &data);
protected: 
	int	Connect_to_server();
	void	create_requestHead();
	virtual void	recv_server(int sockfd);
	bool	analysis_url(const string &url);

	//signal handler
	typedef sigc::signal<void, string> type_signal_something;
	string	m_host;
	string	m_path;
	string m_requestHead, m_ResponseHead, m_ResponseText;
	pthread_t pid;
	type_signal_something m_signal_something;

public:
	type_signal_something signal_something();
};
int Strcpy(string *dst, const string &src,  int pos, char end);
#endif
