#include "window.h"

bool aa(GdkEventButton *event)
{
	cout << endl;
}
MainWindow::MainWindow()
	: m_previous("Previous"),
	  m_next("Next"),
	  m_search("Search"),
	  m_page(0)
{
	set_title("Music Downloads");

	add(m_MainBox);

	m_http.signal_something().connect(sigc::mem_fun(this, &MainWindow::on_readFinish));
	m_search.signal_clicked().connect(sigc::mem_fun(this, &MainWindow::on_search_click));
	m_previous.signal_clicked().connect(sigc::mem_fun(this, &MainWindow::on_previous_click));
	m_next.signal_clicked().connect(sigc::mem_fun(this, &MainWindow::on_next_click));


	m_label.set_text("Stat: No.");
	m_TreeView.set_parent_window(this);
	
	m_scroll.add(m_TreeView);
	m_MainBox.pack_start(m_VBox0, false, true);
	m_MainBox.pack_start(m_scroll);
	m_VBox0.pack_start(m_HBox0, false, true);
	m_VBox0.pack_start(m_HBox1, false, true);
	m_HBox0.pack_start(m_editText);
	m_HBox0.pack_end(m_search, PACK_SHRINK);
	m_HBox1.pack_start(m_label, PACK_SHRINK);
	m_HBox1.pack_end(m_next, PACK_SHRINK);
	m_HBox1.pack_end(m_previous, PACK_SHRINK);

	show_all_children();
}

MainWindow::~MainWindow()
{
	
}

void MainWindow::on_readFinish(const string data)
{
	if(!search_data_to_window(data)) {
		m_label.set_text("Sate: Not found");
	}
}

bool MainWindow::search_data_to_window(const string &data)
{
	int	pos = 0;
	string	number, musicID, title, artists;
	if( (pos = data.find(NUMBER, 0)) == string::npos) {
		return false;
	}
	Strcpy(&number, data, pos += strlen(NUMBER), '<');
	m_label.set_text("Sate: Search finished");

	while( (pos = data.find(MUSIC_ID, pos)) != string::npos) {
		Strcpy(&musicID, data, pos += strlen(MUSIC_ID), '"');

		if( (pos = data.find(MUSIC, pos)) != string::npos) {
			Strcpy(&title, data, pos += strlen(MUSIC), '"');

			int temp = 0;
			if( (temp = title.find("审批文号", 0)) != string::npos) {
				title.erase(temp);
			}
		} else {
			continue;
		}

		if( (pos = data.find(SINGER, pos)) != string::npos) {
			Strcpy(&artists, data, pos += strlen(SINGER), '"');
		} else {
			continue;
		}
		m_TreeView.append_row_data(musicID, title, artists);
	}

	return true;
}

/*
bool MainWindow::download_info_to_window(string &data)
{
	Json::Reader	reader;
	Json::Value	value;

	int i = 0;
	if(reader.parse(data, value)) {
		value = value[i];
		value = value["file_list"];

		for( i = 0; i < value.size(); ++i) {
			cout << value[i]["url"].asString() << endl;
			cout << value[i]["size"].asDouble() << endl;
		}
	}
}*/

void MainWindow::on_search_click()
{
	m_TreeView.clear();
	m_searchText = m_editText.get_text();
	m_label.set_text("Sate: Seraching...");

	string url = Glib::ustring::compose(MUSIC_URL, m_searchText, 0);
	m_http.set_url(url);
	m_http.append_request_head("Connection", "close");
	m_http.get();

}

void MainWindow::on_previous_click()
{
	if(m_searchText.empty()) {
		m_label.set_text("Sate: Please enter a song name");
		return;
	}
	if(--m_page < 0) {
		m_page = 0;
	}

	m_TreeView.clear();
	string url = Glib::ustring::compose(MUSIC_URL, m_searchText, m_page*20);
	m_http.set_url(url);
	m_http.append_request_head("Connection", "close");
	m_http.get();
	
}

void MainWindow::on_next_click()
{
	if(m_searchText.empty()) {
		m_label.set_text("Sate: Please enter a song name");
		return;
	}
	m_TreeView.clear();
	string url = Glib::ustring::compose(MUSIC_URL, m_searchText, ++m_page*20);
	m_http.set_url(url);
	m_http.append_request_head("Connection", "close");
	m_http.get();	
}
